package utils.numbers.hidden {
	
	/**
	 * uint, который нельзя найти сканированием адресов памяти
	 * 
	 * @author gloomyBrain
	 */
	public final class HiddenUint {
		
		private static const HALF_SIZE:int = int.MAX_VALUE / 2;
		
		private var _delta:int;
		private var _storedValue:uint;
		
		/**
		 * @param	value	Значение, которое необходимо спрятать
		 */
		public function HiddenUint(value:uint = 0) {
			
			this.value = value;
			
		}
		
		/**
		 * Спрятанное числовое значение
		 */
		public function get value():uint {
			
			return (_storedValue - _delta);
			
		}
		
		/**
		 * @private
		 */
		public function set value(value:uint):void {
			
			var randomDelta:uint = uint(Math.random() * HALF_SIZE);
			
			_delta = (value > HALF_SIZE) ? -randomDelta : randomDelta;
			
			_storedValue = value + _delta;
			
		}
		
	}

}